package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.dto.scale.NewResultDto;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;
import com.rf.psychological.scale.scaleresult.ScaleConstant;
import com.rf.psychological.utils.Constant;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @description 成人依恋量表
 */
public class AASScale extends BaseScale {
    public AASScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("AASSCALE.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.AASScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //亲近分量表总分
        int score1 = 0;
        //依赖分量表总分
        int score2 = 0;
        //焦虑分量表总分
        int score3 = 0;
        //亲近依赖均分
        double scoreA = 0;
        //焦虑均分
        double scoreB = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if ((i + 1) == 1 || (i + 1) == 6 || (i + 1) == 8 || (i + 1) == 12 || (i + 1) == 13 || (i + 1) == 17) {
                if (jsonObject1.getString("scoreDirection").equals("1")) {
                    if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                        score1 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                        score1 += 5;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                        score1 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                        score1 += 1;
                    }
                }
            } else if ((i + 1) == 2 || (i + 1) == 5 || (i + 1) == 7 || (i + 1) == 14 || (i + 1) == 16 || (i + 1) == 18) {
                if (jsonObject1.getString("scoreDirection").equals("1")) {
                    if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                        score2 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                        score2 += 5;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                        score2 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                        score2 += 1;
                    }
                }
            } else {
                if (jsonObject1.getString("scoreDirection").equals("1")) {
                    if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                        score3 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                        score3 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                        score3 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                        score3 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                        score3 += 5;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                        score3 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                        score3 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                        score3 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                        score3 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                        score3 += 1;
                    }
                }
            }
        }

        DecimalFormat df = new DecimalFormat("######0.00");

        scoreA = Double.parseDouble(df.format((score1 + score2) / 12.0));
        scoreB = Double.parseDouble(df.format(score3 / 6.0));

        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("亲近依赖均分", String.valueOf(scoreA));
        resultMap.put("焦虑均分", String.valueOf(scoreB));

        resultJson.put("亲近依赖均分", String.valueOf(scoreA));
        resultJson.put("焦虑均分", String.valueOf(scoreB));


        if (scoreA > 3 && scoreB < 3) {
            resultMap.put("解读", "安全型");
            resultJson.put("解读", "安全型");
        } else if (scoreA > 3 && scoreB > 3) {
            resultMap.put("解读", "先占型");
            resultJson.put("解读", "先占型");
        } else if (scoreA < 3 && scoreB < 3) {
            resultMap.put("解读", "拒绝型");
            resultJson.put("解读", "拒绝型");
        } else if (scoreA < 3 && scoreB > 3) {
            resultMap.put("解读", "恐惧型");
            resultJson.put("解读", "恐惧型");
        }


        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_AAS);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }

    public JSONObject scaleCalculateV2() throws Exception {

        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String, String>> resultMapList = new ArrayList<>();

        //亲近分量表总分
        int score1 = 0;
        //依赖分量表总分
        int score2 = 0;
        //焦虑分量表总分
        int score3 = 0;
        //亲近依赖均分
        double scoreA = 0;
        //焦虑均分
        double scoreB = 0;

        //新版本数据格式
        Map<String, Object> newResult = new LinkedHashMap<>();

        //返回值以及存数据库格式
        List<NewResultDto> newResultDtos = new ArrayList<>();

        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        if (jsonArray.size() > 0) {
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                if ((i + 1) == 1 || (i + 1) == 6 || (i + 1) == 8 || (i + 1) == 12 || (i + 1) == 13 || (i + 1) == 17) {
                    if (jsonObject1.getString("scoreDirection").equals("1")) {
                        if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                            score1 += 1;
                        } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                            score1 += 2;
                        } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                            score1 += 3;
                        } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                            score1 += 4;
                        } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                            score1 += 5;
                        }
                    } else {
                        if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                            score1 += 5;
                        } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                            score1 += 4;
                        } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                            score1 += 3;
                        } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                            score1 += 2;
                        } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                            score1 += 1;
                        }
                    }
                } else if ((i + 1) == 2 || (i + 1) == 5 || (i + 1) == 7 || (i + 1) == 14 || (i + 1) == 16 || (i + 1) == 18) {
                    if (jsonObject1.getString("scoreDirection").equals("1")) {
                        if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                            score2 += 1;
                        } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                            score2 += 2;
                        } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                            score2 += 3;
                        } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                            score2 += 4;
                        } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                            score2 += 5;
                        }
                    } else {
                        if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                            score2 += 5;
                        } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                            score2 += 4;
                        } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                            score2 += 3;
                        } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                            score2 += 2;
                        } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                            score2 += 1;
                        }
                    }
                } else {
                    if (jsonObject1.getString("scoreDirection").equals("1")) {
                        if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                            score3 += 1;
                        } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                            score3 += 2;
                        } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                            score3 += 3;
                        } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                            score3 += 4;
                        } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                            score3 += 5;
                        }
                    } else {
                        if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                            score3 += 5;
                        } else if (jsonObject1.getString("checkItems").equals("较不符合")) {
                            score3 += 4;
                        } else if (jsonObject1.getString("checkItems").equals("不能确定")) {
                            score3 += 3;
                        } else if (jsonObject1.getString("checkItems").equals("较符合")) {
                            score3 += 2;
                        } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                            score3 += 1;
                        }
                    }
                }
            }

            DecimalFormat df = new DecimalFormat("######0.00");

            scoreA = Double.parseDouble(df.format((score1 + score2) / 12.0));
            scoreB = Double.parseDouble(df.format(score3 / 6.0));
            if (scoreA > 3 && scoreB < 3) {
                newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "安全型", "亲密关系和相互依赖安心，乐观、好交际。在感情上很容易接近他人。不管是依赖他人还是被人依赖都感觉心安。不会担忧独处和不为人接纳。", "无",
                        "无", "无", "无", "是"));
            } else if (scoreA > 3 && scoreB > 3) {
                newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "先占型", "对有损亲密关系的任何威胁都不安和警惕，贪婪、妒忌。希望在亲密关系中投入全部的感情，但经常发现他人并不乐意杷关系发展到如自己期望的那般亲密。没有亲密关系让我不安，有时还担心伴侣不会像我看重他一样看重我。", "无",
                        "无", "无", "无", "是"));
            } else if (scoreA < 3 && scoreB < 3) {
                newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "拒绝型", "自立，漠视亲密关系，冷淡、独立。即使没有亲密关系也安心。对我而言，独立和自给自足更加重要，我不喜欢依赖别人或让人依赖。", "无",
                        "无", "无", "无", "是"));
            } else if (scoreA < 3 && scoreB > 3) {
                newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "恐惧型", "害怕被遗弃，不信任他人，猜忌多疑、害羞。和他人发生亲密接触使我不安。感情上我渴望亲密关系，但很难完全相信他人或依赖他人。担心自己和他人变得太亲密会受到伤害。", "无",
                        "无", "无", "无", "是"));
            }
            resultMap0.put("总分", String.valueOf(score));
            resultJson.put("总分", String.valueOf(score));

            resultMapList.add(resultMap0);
        }


        //需要图表展示的
        newResult.put("iconInfo", "");
        newResult.put("result", newResultDtos);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        //returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson", resultJson);
        returnJson.put(ScaleConstant.ResultEnum.RESULT_NEW_FIELD.getKeyword(), newResult);

        return returnJson;
    }
}
